function uploaddialog(){
	
	var ioService = Components
		.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService);
	var nsIFilePicker = Components
		.classes["@mozilla.org/filepicker;1"]
		.createInstance(Components.interfaces.nsIFilePicker);
	
	nsIFilePicker.init(
		window,
		"Open file",
		Components.interfaces.nsIFilePicker.modeOpen
	);
	
	nsIFilePicker.appendFilter("All files", "*.*");
	
	if (nsIFilePicker.show() == Components.interfaces.nsIFilePicker.returnOK)
	{
		obj_uploader.fnc_uploadFile(
			nsIFilePicker.file,
			
			function(reqResponse, pendingUploadCount){
				alert('pending uploads count: '+pendingUploadCount)
				alert('received response: '+reqResponse)
			}
		);
	}
}

/*var listener = {
	handleEvent: function( event ) {
		dump( "\n" +event.target );
	}
}*/


function refreshUploadLabels ()
{
	var upload_count_global = Application.storage.get('upload_count_global', 0);
	var upload_labels = Application.storage.get('upload_labels', []);
	
	//alert(upload_count_global);
				
	for (var i = 0; i < upload_labels.length; i++)
	{
		if (upload_count_global > 0)
		{
			upload_labels[i].setAttribute('hidden', 'false');
			upload_labels[i].setAttribute('value', upload_count_global + ' ' + ui.locale.getStringFromName('upload.upload'));
		} else	
		{
			upload_labels[i].setAttribute('hidden', 'true');
		}
	}
	
}



var gen_uploader = function(){}

gen_uploader.prototype.arr_uploads = {}
gen_uploader.prototype.arr_upload_watchers = {}
gen_uploader.prototype.var_uploads_count = 0
gen_uploader.prototype.var_uploads_counter = 0

gen_uploader.prototype.var_uploadUrl = null;

gen_uploader.prototype.fnc_uploadFile = function (obj_nsIFile, fnc_callback)
{
	
	//alert("upload function started");
	
	if(this.var_uploadUrl===null)
	{
		alert("No upload url defined!");
	}
	const boundaryString = new Date().getTime()
	var tthis = this
	
	var tmp_file = obj_nsIFile;
	
	var nsIMultiplexInputStream = Components
		.classes["@mozilla.org/io/multiplex-input-stream;1"]
		.createInstance(Components.interfaces.nsIMultiplexInputStream)
	
	var nsIStringInputStream = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	
	nsIStringInputStream.setData(
		"\r\n-----------------------------"
		+ boundaryString
		+ "\r\nContent-Disposition: form-data; name=\"userfile\"; filename=\""
		+ tmp_file.leafName
		+ "\"\r\n\r\n",
		-1
	)
	
	nsIMultiplexInputStream.appendStream(nsIStringInputStream);
	
	//create a binary stream
	var nsIFileInputStream = Components
		.classes["@mozilla.org/network/file-input-stream;1"]
		.createInstance(Components.interfaces.nsIFileInputStream)
	nsIFileInputStream.init(
		tmp_file,
		1,
		1,
		Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF
	)
	var nsIBufferedInputStream = Components
		.classes["@mozilla.org/network/buffered-input-stream;1"]
		.createInstance(Components.interfaces.nsIBufferedInputStream)
	nsIBufferedInputStream.init(nsIFileInputStream, 4096)
	
	nsIMultiplexInputStream.appendStream(nsIBufferedInputStream)
	
	var nsIStringInputStream_end = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	nsIStringInputStream_end.setData(
		"\r\n" + "-----------------------------" + boundaryString + "--\r\n",
		-1
	)
	
	nsIMultiplexInputStream.appendStream(nsIStringInputStream_end)
	
	if(!nsIMultiplexInputStream)
	{
		log("Error [fnc_init]: No output stream")
		return null
	}
	else
	{
		
		tthis.var_uploads_counter = Application.storage.get('uploads_counter', 0); tthis.var_uploads_counter++; Application.storage.set('uploads_counter', tthis.var_uploads_counter);
		tthis.var_uploads_count = Application.storage.get('uploads_count', 0); tthis.var_uploads_count++; Application.storage.set('uploads_count', tthis.var_uploads_count);
		
		
		var count = Application.storage.get('upload_count_global', 0); count++; Application.storage.set('upload_count_global', count);
		refreshUploadLabels();
		
		var tmpCounterID = tthis.var_uploads_counter;
		
		var fullsize = nsIMultiplexInputStream.available();

		tthis.arr_uploads['upload'+tthis.var_uploads_counter] = new XMLHttpRequest();
		
		var req = tthis.arr_uploads['upload'+tthis.var_uploads_counter];
		
		var upload_stats = {};
		upload_stats.size = 0;
		upload_stats.loaded = 0;
		upload_stats.finished = 0;
		
		/*
		this one works since 3.5
		it is ESSENTIAL that the progress handler is hooked BEFORE the other req properties are set. That is why we are doing it here.
		the upload_stats object is meant to track the upload and it is passed to the watch window
		*/
		
		// check if we are running something higher than 3.1
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
		if(appInfo.ID == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}") 
		{
			var appnumber = parseInt(appInfo.version.replace('.',''));
			if (appnumber < 31)
			{
				var no_window = true;
			} else { no_window = false; }
		} else { no_window = false; }
		
		if (! no_window)
		{
			var var_dataBranch = Components
				.classes["@mozilla.org/preferences-service;1"] 
				.getService(Components.interfaces.nsIPrefService)
				.getBranch(const_Cyclone3XULAdminPrefsRoot);
			try{
				no_window = var_dataBranch.getBoolPref('nouploadwindow');
			}
			catch(e){ no_window = false; }
		}
		
		if (! no_window)
		{
			
			var uploads = Application.storage.get('uploads', {});
			
			uploads['upload'+tmpCounterID] = {}; 
			uploads['upload'+tmpCounterID]['filename'] = tmp_file.leafName;
			uploads['upload'+tmpCounterID]['parent_object'] = tthis;
			uploads['upload'+tmpCounterID]['finished'] = 0;
			//uploads['upload'+tmpCounterID]['upload_stats'] = upload_stats;
			
			Application.storage.set('uploads', uploads);	
			
			//req.onuploadprogress = function(evt)
			req.upload.onprogress = function(evt)
			{
				//log('onuploadprogress');
				
				if (evt.lengthComputable)
				{
					var uploads = Application.storage.get('uploads', {});
					
					upload_stats.loaded = evt.loaded;
					upload_stats.size = evt.total;
					
					uploads['upload'+tmpCounterID]['total'] = evt.total;
					uploads['upload'+tmpCounterID]['loaded'] = evt.loaded;
					
					Application.storage.set('uploads', uploads);	
				}
			}
			
			
			// if file is > 500k open a progress window
			
			
			var win = ui.probeOpenWindow('uploads');
			
			if(win)
			{
				win.refreshView();
			}
			
			if (fullsize / 1024 > 500) 
			{	
				if(win)
				{
					//win.focus();
				} else
				{
					var wasclosed = Application.storage.get('uploads_window_closed', 0);
					
					if (wasclosed != 1)
					{
					
					win = openDialog(
					"chrome://c3xuladmin/content/uploads.xul",
					'uploads', ""
					);
					win.focus();
					}
				}
			}
		}
		req.open("POST", tthis.var_uploadUrl, true);
		req.setRequestHeader(
			"Content-Type",
			"multipart/form-data; charset: utf-8; boundary=---------------------------" + boundaryString
		)
		
		
		// notificationCallbacks nsIInterfaceRequestor
		//var irequestor = req.channel.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
		//alert(irequestor);
		//irequestor.getInterface(Components.interfaces.nsIProgressEventSink);
		
		
		//req.notificationCallbacks=requestProgress;
		
		
		//creating listener
		req.onreadystatechange = function(event)
		{
			log('REQUEST: READYSTATE:' + req.readyState );
			// Check response
			if (req.readyState == 4)
			{
				// Clear Timeout
				try
				{
					if (req.status == 200)
					{
						//alles gute
						//alert(req.responseText);
						delete tthis.arr_uploads['upload'+tmpCounterID]
						tthis.var_uploads_count = Application.storage.get('uploads_count', 0); tthis.var_uploads_count--; Application.storage.set('uploads_count', tthis.var_uploads_count);
						fnc_callback(req.responseText, tthis.var_uploads_count, obj_nsIFile);
						upload_stats.finished = 1;
						
						var uploads = Application.storage.get('uploads', {});
						
						uploads['upload'+tmpCounterID]['finished'] = 1;
						uploads['upload'+tmpCounterID]['allright'] = 1;
						
						Application.storage.set('uploads', uploads);
						
						var count = Application.storage.get('upload_count_global', 0); count--; Application.storage.set('upload_count_global', count);
						refreshUploadLabels();
						
					}
					
				}
				catch(e)
				{
					//alert('erore '+e)
					//alert('erore '+req.status);
					//alert('erore '+req.responseText);
					delete tthis.arr_uploads['upload'+tmpCounterID];
					var uploads = Application.storage.get('uploads', {});
					
					uploads['upload'+tmpCounterID]['finished'] = 2;
					Application.storage.set('uploads', uploads);
					tthis.var_uploads_count = Application.storage.get('uploads_count', 0); tthis.var_uploads_count--; Application.storage.set('uploads_count', tthis.var_uploads_count);				
					
					var count = Application.storage.get('upload_count_global', 0); count--; Application.storage.set('upload_count_global', count);
					refreshUploadLabels();
					upload_stats.finished = 2;
					// Error
					//handler.fnc_handleError(
					//	{
					//		IDRequest: id,
					//		errorComponent: 'onreadystatechange',
					//		errorString: 'Could not connect - Domain or connection not available.'
					//	}
					//)
					return
				}
				return
			}
			return
		}
		req.send(nsIMultiplexInputStream);
		
		window.addEventListener("close", function(){
			req.abort(); 
			
			var uploads = Application.storage.get('uploads', {});
			uploads['upload'+tmpCounterID]['finished'] = 2;
			Application.storage.set('uploads', uploads);
			var count = Application.storage.get('upload_count_global', 0); count--; Application.storage.set('upload_count_global', count);
			refreshUploadLabels();
			
		}, false);   
		
	}
}


var global_uploads = Application.storage.get('global_uploads', {});

obj_uploader = new gen_uploader()

/*alert('gen URL')*/

obj_uploader.var_uploadUrl = window.arguments[0].transport_URI + 'upload.pl';

/*alert('upload URI = ' + obj_uploader.var_uploadUrl);*/

global_uploads = obj_uploader;

Application.storage.set('global_uploads', global_uploads);

