const const_Cyclone3XULAdminPrefsRoot = "extensions.cyclone3XULAdmin.preferences.";
const const_required_framework_version = '2010.08.0.5472';

/* global symbols */
try {Components.utils.import("chrome://c3xuladmin/content/jsm/master.jsm")}catch(e)
{alert('Could not import master.jsm');alert(e);}

var core =
{
	// only proof of concept, should be rewritten
	getInstalledVersion : function(Cyclone3XULAdminExtID, callback_function)
	{
		var version = {};
		version.pass = 0;
		version.val = '?';
		Components.utils.import("resource://gre/modules/AddonManager.jsm");
		AddonManager.getAddonByID(Cyclone3XULAdminExtID, callback_function);
	},
	
	update :
	{
		check : function(obj_UpdateListener, Cyclone3XULAdminExtID)
		{
			try{

				// firefox 3.6
	
				var ExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
				var ext = null
				if (ExtensionManager.getItemForID)
				{
					ext = ExtensionManager.getItemForID(Cyclone3XULAdminExtID)
				}
				else
				{
					ext = ExtensionManager.getItemList(Cyclone3XULAdminExtID, null, {})[0]
				}
				ExtensionManager.update([ext], 1, false, obj_UpdateListener)

			}catch(e)
			{
				// firefox 4
			}
		},
		
		executeupdate : function(Cyclone3XULAdminExtID)
		{
			try
			{
				
				var extensionPrefs=new Array()
				
				var prefs = Components
					.classes["@mozilla.org/preferences-service;1"] 
					.getService(Components.interfaces.nsIPrefService)
					.getBranch(const_Cyclone3XULAdminPrefsRoot);
				prefs.setIntPref('helpdisplayed',0);
				
				var ExtensionPrefsBranch = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService)
					.getBranch(const_Cyclone3XULAdminPrefsRoot+'updates.')
				
				var ExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
					
				var startupCheck = ExtensionPrefsBranch.getBoolPref('startupCheck')
				
				if(startupCheck)
				{
					
					if (ExtensionManager.getItemForID)
					{
						ext = ExtensionManager.getItemForID(Cyclone3XULAdminExtID)
					}
					else
					{
						ext = ExtensionManager.getItemList(Cyclone3XULAdminExtID, null, {})[0]
					}
					
					if (typeof(InstallTrigger) != 'undefined')
					{
						var xpi = {}
						xpi[ext.name] = ext.xpiURL
						InstallTrigger.install(xpi)
					}
					else
					{
						alert('Update failed! Could not initialize InstallTrigger')
					}
				}
				
			}
			catch(e){ }
		},

		executeupdate4 : function(extension_id)
		{
			try
			{
				
				//alert('executing update for: ' + extension_id);
				
				//alert(window.update[extension_id]);
	
				var InstallListener4 =
				{
					onNewInstall : function (AddonInstall)
					{
						//alert("onNewInstall");
					},
					
					onDownloadStarted : function (AddonInstall)
					{
						//alert("onDownloadStarted");
					},
					
					onDownloadProgress : function (AddonInstall)
					{
						//alert("onDownloadProgress");
					},
					
					onDownloadEnded : function (AddonInstall)
					{
						//alert("onDownloadEnded");
					},
					
					onDownloadCancelled : function (AddonInstall)
					{
						//alert("onDownloadCancelled");
					},
					
					onDownloadFailed : function (AddonInstall)
					{
						//alert("onDownloadFailed");
					},
					
					onInstallStarted : function (AddonInstall)
					{
						//alert("onInstallStarted");
					},
					
					onInstallEnded : function (AddonInstall , Addon)
					{
						// restart firefox

						try{
							Components.classes["@mozilla.org/toolkit/app-startup;1"].
							getService(Components.interfaces.nsIAppStartup).quit(Components.interfaces.nsIAppStartup.eRestart | Components.interfaces.nsIAppStartup.eAttemptQuit);
						}catch(e){alert(e);}
					},
					
					onInstallCancelled : function (AddonInstall)
					{
						//alert("onInstallCancelled");
					},
					
					onInstallFailed : function (AddonInstall)
					{
						//alert("onInstallFailed");
					},
					
					onExternalInstall : function (AddonInstall , Addon_existing , NeedRestart_bool)
					{
						//alert("onExternalInstall");
					}
					
				}
				
				try{
				window.update[extension_id].addListener(InstallListener4);
				}catch(e){alert(e);}


				try{
				window.update[extension_id].install();
				}catch(e){alert(e);}
				

			}
			catch(e){ }
		}
	}
	
}

var c3xuladmin = 
{
	downloadWithFileDialog : function (url, default_name, default_extension)
	{
		try
		{
			var f_picker = Components.classes["@mozilla.org/filepicker;1"].
						createInstance(Components.interfaces.nsIFilePicker);

			f_picker.defaultString = default_name + '.' + default_extension;
			f_picker.init(window, "", f_picker.modeSave);
			f_picker.appendFilter(default_extension, '*.' + default_extension);

			var result = f_picker.show();
					
              		if ((result == f_picker.returnOK) || (result == f_picker.returnReplace)) 
			{
				//var target_file = f_picker.file;

				this.downloadSilent(url, f_picker.file, default_name + '.' + default_extension);

				
			}

		}catch(e){alert(e);}
	},

	downloadSilent : function (url, target_file, description)
	{
		try
		{
			/* this will only work for FF > 26.0 */

			Components.utils.import("resource://gre/modules/Downloads.jsm");
			download = Downloads.fetch(url, target_file);

			/*

			var iio_service = Components.classes["@mozilla.org/network/io-service;1"].
					getService(Components.interfaces.nsIIOService);

			var uri_source = iio_service.newURI(url, null, null);
			var uri_target = iio_service.newFileURI(target_file);

			var web_br_persist = Components.interfaces.nsIWebBrowserPersist;
			var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
					createInstance(web_br_persist);

			persist.persistFlags = web_br_persist.PERSIST_FLAGS_REPLACE_EXISTING_FILES |
			web_br_persist.PERSIST_FLAGS_BYPASS_CACHE |
			web_br_persist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
			
			var d_manager = Components.classes["@mozilla.org/download-manager;1"].
					createInstance(Components.interfaces.nsIDownloadManager);

			var download = d_manager.addDownload(d_manager.DOWNLOAD_TYPE_DOWNLOAD, uri_source, uri_target,
				description,null, Math.round(Date.now() * 1000),
				null, persist);
			persist.progressListener = download.QueryInterface(Components.interfaces.nsIWebProgressListener);
			persist.saveURI(download.source, null, null, null, null, download.targetFile);

			
			var download_m = Components.classes["@mozilla.org/download-manager-ui;1"].
			createInstance(Components.interfaces.nsIDownloadManagerUI);
			download_m.show(window, download.id, Components.interfaces.nsIDownloadManagerUI.REASON_NEW_DOWNLOAD);
			*/

		}catch(e){alert(e);}
	}
}

//var log: function core.


